#include <stdio.h>
#include <stdbool.h>

void print3(int m[3][3])
{
  for (int i = 0; i < 3; i++)
  {
    for (int j = 0; j < 3; j++)
    {
      printf("%d", m[i][j]);
    }
    printf("\n");
  }
}

bool est_carre_magique()
{
  /* création tu tableau */
  int m[3][3];
  int chiffres_utilises[10] = {0,0,0,0,0,0,0,0,0,0};

  /* remplissage du tableau */
  int read;
  int cont = 1;
  for (int i = 0; i < 3; i++)
  {
    for (int j = 0; j < 3; j++)
    {
      cont = true;
      while (cont)
      {
        printf("%d-%d: ", i, j);
        scanf("%d", &read);
        if (chiffres_utilises[read] != 0)
        {
          printf("chiffre déjà utilisé.\n");
          fflush(stdout);
        } else {
          cont = 0;
          chiffres_utilises[read] = 1;
          m[i][j] = read;
        }
      }

    }
  }

  /* vérification du carré magique */
  int somme = 0; /* on calcule la somme de la première ligne */
  for (int j = 0; j < 3; j++)
  {
    somme += m[0][j];
  }

  int other_somme = 0;
  for (int i = 1; i < 3; i++)
  { /* on somme les autres lignes et on vérifie que
       la somme est celle de la première ligne */
    other_somme = 0;
    for (int j = 0; j < 3; j++)
    {
      other_somme += m[0][j];
    }
    if (other_somme != somme)
    {
      return false;
    }
  }

  for (int j = 0; j < 3; j++)
  { /* on somme les colonnes et on vérifie que la
       somme est celle de la première ligne */
    other_somme = 0;
    for (int i = 0; i < 3; i++)
    {
      other_somme += m[i][j];
    }
    if (other_somme != somme)
    {
      return false;
    }
  }

  other_somme = 0;
  for (int k = 0; k < 3; k++)
  { /* on somme la première diagonale et on vérifie
       que la somme est celle de la première ligne */
    other_somme += m[k][k];
  }
  if (other_somme != somme)
  {
    return false;
  }

  other_somme = 0;
  for (int k = 0; k < 3; k++)
  { /* on somme la seconde diagonale et on vérifie
       que la somme est celle de la première ligne */
    other_somme += m[k][2-k];
  }
  if (other_somme != somme)
  {
    return false;
  }

  /* si on atteint ce point de programme c'est
     qu'aucune des sommes ne différaient de celle
     de la première ligne. */
  return true;
}


void print5(int m[5][5])
{
  for (int i = 0; i < 5; i++)
  {
    for (int j = 0; j < 5; j++)
    {
      printf("%d", m[i][j]);
    }
    printf("\n");
  }
}


void fill(int m[5][5], int n)
{
  for (int i = 0; i < 5; i++)
  {
    for (int j = 0; j < 5; j++)
    {
      m[i][j] = n;
    }
  }
}


void pascal(int m[5][5])
{
  for (int i = 0; i < 5; i++)
  {
    for (int j = 0; j <= i; j++)
    {
      if (j == 0)
      {
        m[i][j] = 1;
      }
      else
      {
        m[i][j] = m[i-1][j-1] + m[i-1][j];
      }
    }
  }
}

/*** fonction main ***/
int main()
{
  printf("%d\n", est_carre_magique());
  /*
  int m[5][5];
  fill(m, 0);
  pascal(m);
  print5(m);
  */
}
